$: << File.dirname(__FILE__)

require "App42_RUBY_SDK/version"

# module App42RUBYSDK
#   puts VERSION
# end

# -----------------------------------------------------------------------
#  Copyright © 2012 ShepHertz Technologies Pvt Ltd. All rights reserved.
# -----------------------------------------------------------------------

#!/usr/bin/env ruby

require 'user/UserService'
require 'storage/Query'
require 'storage/QueryBuilder'
require 'storage/OrderByType'
require 'storage/StorageService'
require 'push/DeviceType'
require 'push/PushNotification'
require 'push/PushNotificationService'
require 'upload/UploadService'
require 'upload/UploadFileType'
require 'session/SessionService'
require 'geo/GeoService'
require 'geo/GeoPoint'
require 'gallery/AlbumService'
require 'gallery/PhotoService'
require 'log/LogService'
require 'recommend/RecommenderService'
require 'recommend/RecommenderSimilarity'
require 'game/GameService'
require 'game/RewardService'
require 'game/ScoreBoardService'
require 'game/ScoreService'
require 'review/ReviewService'
require 'social/SocialService'
require 'email/EmailService'
require 'email/EmailMIME'
require 'message/QueueService'
require 'storage/StorageService'
require 'shopping/CartService'
require 'shopping/PaymentStatus'
require 'shopping/CatalogueService'
require 'imageProcessor/ImageProcessorService'

require 'time'

module App42
  class ServiceAPI
    attr_accessor :api_key, :secret_key, :base_url, :content_type, :accept

    @@JSON_MIME_TYPE = "application/json"
    @@XML_MIME_TYPE = "application/xml"
    def initialize(api_key, secret_key)
      puts "Initializer Called "
      @api_key = api_key
      @secret_key = secret_key
      @base_url = "http://localhost:8082/App42_API_SERVER/cloud/"
      @content_type = "application/json"
      @accept = "application/json"
    end

    def buildUserService
      puts "Build User Called "
      user = App42::User::UserService.new(api_key, secret_key, base_url)
      user
    end

    def buildSessionService
      puts "Build Session Called "
      session = App42::Session::SessionService.new(api_key, secret_key, base_url)
      session
    end

    def buildReviewService
      puts "Build Review Called "
      review = App42::Review::ReviewService.new(api_key, secret_key, base_url)
      review
    end

    def buildSocialService
      puts "Build social Called "
      social = App42::Social::SocialService.new(api_key, secret_key, base_url)
      social
    end

    def buildEmailService
      puts "Build email service Called "
      email = App42::Email::EmailService.new(api_key, secret_key, base_url)
      email
    end

    def buildAlbumService
      puts "Build Album service Called "
      album = App42::Gallery::AlbumService.new(api_key, secret_key, base_url)
      album
    end

    def buildPhotoService
      puts "Build Photo service Called "
      photo = App42::Gallery::PhotoService.new(api_key, secret_key, base_url)
      photo
    end

    def buildGameService
      puts "Build Game service Called "
      game = App42::Game::GameService.new(api_key, secret_key, base_url)
      game
    end

    def buildRewardService
      puts "Build Reward service Called "
      reward = App42::Game::RewardService.new(api_key, secret_key, base_url)
      reward
    end

    def buildScoreBoardService
      puts "Build Score Board service Called "
      scoreboard = App42::Game::ScoreBoardService.new(api_key, secret_key, base_url)
      scoreboard
    end

    def buildScoreService
      puts "Build Score service Called "
      score = App42::Game::ScoreService.new(api_key, secret_key, base_url)
      score
    end

    def buildQueueService
      puts "Build Queue service Called "
      queue = App42::Message::QueueService.new(api_key, secret_key, base_url)
      queue
    end

    def buildStorageService
      puts "Build Storage service Called "
      storage = App42::Storage::StorageService.new(api_key, secret_key, base_url)
      storage
    end

    def buildCartService
      puts "Build Cart Called "
      cart = App42::Shopping::CartService.new(api_key, secret_key, base_url)
      cart
    end

    def buildStorageService
      puts "build Storage service Called "
      storage = App42::Storage::StorageService.new(api_key, secret_key, base_url)
      storage
    end

    def buildUploadService
      puts "upload Storage service Called "
      upload = App42::Upload::UploadService.new(api_key, secret_key, base_url)
      upload
    end

    def buildImageProcessorService
      puts "Build Image Processor service Called "
      image = App42::ImageProcessor::ImageProcessorService.new(api_key, secret_key, base_url)
      image
    end

    def buildCatalogueService
      puts "Build Catalogue service Called "
      catalogue = App42::Shopping::CatalogueService.new(api_key, secret_key, base_url)
      catalogue
    end

    def buildLogService
      puts "Build Log service Called "
      log = App42::Log::LogService.new(api_key, secret_key, base_url)
      log
    end

    def buildGeoService
      puts "Build Geo service Called "
      geo = App42::Geo::GeoService.new(api_key, secret_key, base_url)
      geo
    end

    def buildRecommendService
      puts "Build Recommender service Called "
      recommend = App42::Recommend::RecommenderService.new(api_key, secret_key, base_url)
      recommend
    end

    def buildBillService
      puts "Build Bill service Called "
      bill = App42::AppTab::BillService.new(api_key, secret_key, base_url)
      bill
    end

    def buildLicenseService
      puts "Build License service Called "
      license = App42::AppTab::LicenseService.new(api_key, secret_key, base_url)
      license
    end

    def buildUsageService
      puts "Build Usage service Called "
      usage = App42::AppTab::UsageService.new(api_key, secret_key, base_url)
      usage
    end

    def buildPushNotificationService
      puts "Build Push Notification service Called "
      push = App42::Push::PushNotificationService.new(api_key, secret_key, base_url)
      push
    end

    def buildSchemeService
      puts "Build Scheme service Called "
      scheme = App42::AppTab::SchemeService.new(api_key, secret_key, base_url)
      scheme
    end

    def buildPackageService
      puts "Build Scheme service Called "
      package = App42::AppTab::PackageService.new(api_key, secret_key, base_url)
      package
    end

    def buildDiscountService
      puts "Build Discount service Called "
      discount = App42::AppTab::DiscountService.new(api_key, secret_key, base_url)
      discount
    end

  end
end


