# -----------------------------------------------------------------------
#  Copyright © 2012 ShepHertz Technologies Pvt Ltd. All rights reserved.
# -----------------------------------------------------------------------

require 'App42Response.rb'

#
#
# This Album object is the value object which contains the properties of Album.
#
#

module App42
  module Gallery
    class Album < App42Response
      attr_accessor :userName, :name,:description, :photoList

      @userName
      @name
      @description
      @photoList = Array.new()
    end

    class Photo
      attr_accessor :name, :description, :url, :thumbNailTinyUrl, :tinyUrl, :tagList, :thumbNailUrl

      @name
      @description
      @url
      @thumbNailUrl
      @tagList = Array.new
      @tinyUrl
      @thumbNailTinyUrl

      #
      # This is a constructor that takes no parameter
      #
      #
      def initialize(album)
        album.photoList.push(self)
      end

      #
      # Returns the Album Response in JSON format.
      #
      # @return the response in JSON format.
      #
      #

      def to_s
        return "name : #{@name}" + "description : #{@description}" + "url : #{@url}"  + "tinyUrl : #{@tinyUrl}" + "thumbNailUrl : #{@thumbNailUrl}" + "thumbNailTinyUrl : #{@thumbNailTinyUrl}" + "tagList : #{@tagList }"
      end

    end
  end
end