# -----------------------------------------------------------------------
#  Copyright © 2012 ShepHertz Technologies Pvt Ltd. All rights reserved.
# -----------------------------------------------------------------------

require 'json/pure'
require 'App42ResponseBuilder.rb'
require 'message/Queue.rb'

module App42
  module Message

    #
    #
    # QueueResponseBuilder class converts the JSON response retrieved from the
    # server to the value object i.e Queue
    #
    #
    class QueueResponseBuilder < App42ResponseBuilder

      #
      # Converts the response in JSON format to the value object i.e Queue
      #
      # @param json
      #      - response in JSON format
      #
      # @return Queue object filled with json data
      #
      #
      def buildResponse(json)
        puts "testing #{json}"
        queuesJSONObj = getServiceJSONObject("queues", json)
        queueJSONObj =  queuesJSONObj["queue"]
        queueObj = Queue.new()

        messageList = Array.new
        queueObj.messageList=(messageList)

        queueObj.strResponse=json
        queueObj.isResponseSuccess= isResponseSuccess(json)
        buildObjectFromJSONTree(queueObj, queueJSONObj);

        if queueJSONObj.key?("messages") == false
          return queueObj
        end
        if queueJSONObj.fetch("messages").key?("message") == false
          return queueObj
        end
        if queueJSONObj.fetch("messages").fetch("message").instance_of?(Hash)
          messageObj = App42::Message::Message.new(queueObj)
          buildObjectFromJSONTree(messageObj,queueJSONObj.fetch("messages").fetch("message"));
        else
          messagesJSONArray = queueJSONObj.fetch("messages").fetch("message");
          messagesJSONArray.length.times do |i|
            messageJSONObj = messagesJSONArray[i]
            messageObj = App42::Message::Message.new(queueObj)
            buildObjectFromJSONTree(messageObj, messageJSONObj);
          end

        end
        return queueObj
      end
    end
  end
end