# -----------------------------------------------------------------------
#  Copyright © 2012 ShepHertz Technologies Pvt Ltd. All rights reserved.
# -----------------------------------------------------------------------

require 'App42Response.rb'

#
#
# This Recommender object is the value object which contains the properties of
# Recommender.
#
#

module App42
  module Recommend
    class Recommender < App42Response
      attr_accessor :fileName, :recommendedItemList

      @fileName
      @recommendedItemList = Array.new()
    end

    class RecommendedItem
      attr_accessor :userId, :item, :value
      @userId
      @item
      @value

      #
      # This is a constructor that takes no parameter
      #
      def initialize(recommender)
        recommender.recommendedItemList.push(self)
      end

      #
      # Returns the Recommender Response in JSON format.
      #
      # @return the response in JSON format.
      #

      def to_s
        return "UserId : #{self.userId}" + "item : #{self.item}" + "value : #{self.value}";
      end

    end
  end
end
